// Do the same thing as AverageColour, but
// use the pixels array inside of a PImage.
// Given that we'll eventually read every
// pixel in the image, this version will 
// probably be faster.

void setup()
{
  PImage img = loadImage( "otis.jpg" );
  int r = 0;
  int g = 0;
  int b = 0;
  int sz = img.width * img.height;
  img.loadPixels();

  for ( int idx = 0; idx < sz; ++idx ) {
    // Because we know we'll just read from
	// every pixel in order, we don't need to
	// fiddle with nested loops over X and Y.
    color c = img.pixels[idx];
    r += red( c );
    g += green( c );
    b += blue( c );
  }

  color avg = color(
  r/float(sz), 
  g/float(sz), 
  b/float(sz) );
  background( avg );
}

