// Run something like the Halftoning sketch, but with live
// input from the camera.

import processing.video.*;

Capture cam;
int dim = 15;

void setup()
{
  size( dim * 40, dim * 30 );

  // Create a new instance to represent the camera.
  cam = new Capture( this, 400, 300 );
  // Essential: tell the camera to actually start recording.
  cam.start();
}

void draw()
{
  if ( cam.available() ) {
    cam.read();
    PImage img = cam.get();
    img.resize( 40, 0 );
    background( 0 );
    drawTiles( img );
  }
}

void drawTiles( PImage img )
{
  fill( 255 );
  noStroke();
  rectMode( CENTER );
  
  for( int row = 0; row < img.height; ++row ) {
    for( int col = 0; col < img.width; ++col ) {
	  // This line is a bit different from the Halftoning sketch.
	  // flip the x values here to make sure you get a mirror.

      float b = norm( brightness( img.get( img.width-1-col, row ) ), 0, 255 );
      float sz = dim * sqrt( b );
      // rect( (col+0.5)*dim, (row+0.5)*dim, sz, sz );
      ellipse( (col+0.5)*dim, (row+0.5)*dim, sz, sz );
    }
  }
}

