// A simplest demonstration of using the webcam.  Create
// a mirror.  The extra trick is to use geometric context
// to flip the camera's input horizontally before displaying
// it.

import processing.video.*;

Capture cam;

void setup()
{
  size( 320, 240 );

  // Create a new instance to represent the camera.
  cam = new Capture( this, 320, 240 );
  // Essential: tell the camera to actually start recording.
  cam.start();
}

void draw()
{
  if ( cam.available() ) {
    cam.read();
    pushMatrix();
    translate( 320, 0 );
    scale( -1, 1 );
    image( cam, 0, 0 );
    popMatrix();
  }
}
