// Demonstrate the simple case of rotating an image by 90 
// degrees, which can be computed exactly without using 
// the potentially imprecise tool of geometric context.

PImage img;
PImage rimg;

void setup()
{
  img = loadImage( "otis.jpg" );
  rimg = createImage( img.height, img.width, RGB );
  img.loadPixels();
  rimg.loadPixels();
  
  int w = img.width;
  int h = img.height;
  
  int row_start = (w-1)*h;

  for( int y = 0; y < h; ++y ) {
    int cur = row_start + y;
    
    for( int x = 0; x < w; ++x ) {
      color c = img.pixels[y*w+x];
      rimg.pixels[ cur ] = c;
      cur -= img.height;
    }
  }
  rimg.updatePixels();
  
  size( rimg.width, rimg.height );
  image( rimg, 0, 0 );
}
