// A basic implementation of a sliding fifteen puzzle.
// Use the arrow keys to move tiles around into the
// empty slot in the puzzle.

PImage img;

int dx;
int dy;

// Where's the empty cell in the grid?
int black_x;
int black_y;

void setup()
{
  img = loadImage( "otis.jpg" );
  size( img.width, img.height );
  dx = img.width / 4;
  dy = img.height / 4;
  image( img, 0, 0 );
  fill( 0 );
  noStroke();
  rect( 3*dx, 3*dy, dx, dy );
  black_x = 3;
  black_y = 3;
  
  for( int idx = 0; idx < 1000; ++idx ) {
    int mv = int( random( 4 ) );
    if( mv == 0 ) {
      doMovement( UP );
    } else if( mv == 1 ) {
      doMovement( DOWN );
    } else if( mv == 2 ) {
      doMovement( LEFT );
    } else if( mv == 3 ) {
      doMovement( RIGHT );
    }
  }
}

PImage getTile( int x, int y )
{
  return get( x*dx, y*dy, dx, dy );
}

void swapTiles( int x1, int y1, int x2, int y2 )
{
  PImage t1 = getTile( x1, y1 );
  PImage t2 = getTile( x2, y2 );
  image( t2, x1*dx, y1*dy );
  image( t1, x2*dx, y2*dy );
  
  if( black_x == x1 && black_y == y1 ) {
    black_x = x2;
    black_y = y2;
  } else if( black_x == x2 && black_y == y2 ) {
    black_x = x1;
    black_y = y1;
  }
}

void draw()
{}

void doMovement( int code )
{
  if( code == LEFT ) {
    if( black_x < 3 ) {
      swapTiles( black_x, black_y, black_x + 1, black_y );
    }
  } else if( code == RIGHT ) {
    if( black_x > 0 ) {
      swapTiles( black_x, black_y, black_x - 1, black_y );
    }
  } else if( code == UP ) {
    if( black_y < 3 ) {
      swapTiles( black_x, black_y, black_x, black_y + 1 );
    } 
  } else if( code == DOWN ) {
    if( black_y > 0 ) {
      swapTiles( black_x, black_y, black_x, black_y - 1 );
    }
  }
}

void keyPressed()
{
  doMovement( keyCode );
}
