// A simple demonstration of tile-based halftoning of an image.

PImage img;
int dim = 15;

void setup()
{
  img = loadImage( "otis.jpg" );
  img.resize( 0, 40 );
  
  size( dim*img.width, dim*img.height );
  
  background( 255 );
  drawTiles( img );
}

void drawTiles( PImage img )
{
  fill( 0 );
  noStroke();
  rectMode( CENTER );
  
  for( int row = 0; row < img.height; ++row ) {
    for( int col = 0; col < img.width; ++col ) {
      float b = norm( brightness( img.get( col, row ) ), 255, 0 );
      float sz = dim * sqrt( b );
      // println( sz );
      // rect( (col+0.5)*dim, (row+0.5)*dim, sz, sz );
      ellipse( (col+0.5)*dim, (row+0.5)*dim, sz, sz );
    }
  }
}
