// The basic framework for a sketch that applies some
// transformation to every colour in a source image.

PImage img;

void setup()
{
  img = loadImage( "otis.jpg" );
  size( img.width, img.height );
}

void draw()
{
  // prepare to write to the sketch window
  loadPixels();
  // prepare to read from the image
  img.loadPixels();

  for( int y = 0; y < img.height; ++y ) {
    for( int x = 0; x < img.width; ++x ) {
      color c = img.pixels[ y*width+x ];
      color c2 = processColour( c );
      pixels[ y*width+x ] = c2;
    }
  }
  
  // Send the pixels to the sketch window.
  updatePixels();
}

// See the rest 
color processColour( color c )
{
  // The "trivial" colour processing function:
  // just return the input colour.
  return c;
}
